Index: /branches/network/src/world_entities/space_ships/hover.cc
===================================================================
--- /branches/network/src/world_entities/space_ships/hover.cc	(revision 6693)
+++ /branches/network/src/world_entities/space_ships/hover.cc	(revision 6693)
@@ -0,0 +1,476 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: Benjamin Knecht
+   co-programmer: ...
+
+*/
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD_ENTITY
+
+#include "hover.h"
+
+#include "weapons/weapon_manager.h"
+#include "weapons/test_gun.h"
+#include "weapons/turret.h"
+#include "weapons/cannon.h"
+
+#include "factory.h"
+#include "key_mapper.h"
+#include "event_handler.h"
+#include "state.h"
+
+#include "graphics_engine.h"
+
+using namespace std;
+
+CREATE_FACTORY(Hover, CL_HOVER);
+
+/**
+ *  creates the controlable Spaceship
+ */
+Hover::Hover()
+{
+  this->init();
+}
+
+/**
+ *  destructs the spaceship, deletes alocated memory
+ */
+Hover::~Hover ()
+{
+}
+
+/**
+ * loads a Spaceships information from a specified file.
+ * @param fileName the name of the File to load the spaceship from (absolute path)
+ */
+Hover::Hover(const char* fileName)
+{
+  this->init();
+  TiXmlDocument doc(fileName);
+
+  if(!doc.LoadFile())
+  {
+    PRINTF(2)("Loading file %s failed for Hover.\n", fileName);
+    return;
+  }
+
+  this->loadParams(doc.RootElement());
+}
+
+/**
+ *  creates a new Spaceship from Xml Data
+ * @param root the xml element containing spaceship data
+
+   @todo add more parameters to load
+*/
+Hover::Hover(const TiXmlElement* root)
+{
+  this->init();
+  if (root != NULL)
+    this->loadParams(root);
+
+  //weapons:
+  Weapon* wpRight = new TestGun(0);
+  wpRight->setName("testGun Right");
+  Weapon* wpLeft = new TestGun(1);
+  wpLeft->setName("testGun Left");
+  Weapon* cannon = dynamic_cast<Weapon*>(Factory::fabricate(CL_CANNON));
+
+  cannon->setName("BFG");
+
+  this->addWeapon(wpLeft, 1, 0);
+  this->addWeapon(wpRight,1 ,1);
+  this->addWeapon(cannon, 0, 6);
+
+  //this->addWeapon(turret, 3, 0);
+
+  this->getWeaponManager()->changeWeaponConfig(1);
+  dynamic_cast<Element2D*>(this->getWeaponManager()->getFixedTarget())->setVisibility( false);
+}
+
+
+/**
+ * initializes a Hover
+ */
+void Hover::init()
+{
+//  this->setRelDir(Quaternion(M_PI, Vector(1,0,0)));
+  this->setClassID(CL_HOVER, "Hover");
+
+  PRINTF(4)("HOVER INIT\n");
+
+  this->loadModel("models/ships/fighter.obj", 1.0);
+
+  EventHandler::getInstance()->grabEvents(true);
+
+  bUp = bDown = bLeft = bRight = bAscend = bDescend = bRollL = bRollR = false;
+  bFire = false;
+  xMouse = yMouse = 0;
+  mouseSensitivity = 0.05;
+
+
+  this->velocity = Vector(0.0,0.0,0.0);
+  this->velocityDir = Vector(1.0,0.0,0.0);
+
+//   GLGuiButton* button = new GLGuiPushButton();
+//   button->show();
+//   button->setLabel("orxonox");
+//   button->setBindNode(this);
+
+  //add events to the eventlist
+  registerEvent(KeyMapper::PEV_UP);
+  registerEvent(KeyMapper::PEV_DOWN);
+  registerEvent(KeyMapper::PEV_LEFT);
+  registerEvent(KeyMapper::PEV_RIGHT);
+  registerEvent(SDLK_e);
+  registerEvent(SDLK_c);
+  registerEvent(KeyMapper::PEV_FIRE1);
+  registerEvent(KeyMapper::PEV_NEXT_WEAPON);
+  registerEvent(KeyMapper::PEV_PREVIOUS_WEAPON);
+  registerEvent(EV_MOUSE_MOTION);
+
+  this->getWeaponManager()->setSlotCount(7);
+
+  this->getWeaponManager()->setSlotPosition(0, Vector(-2.6, .1, -3.0));
+  this->getWeaponManager()->setSlotCapability(0, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+
+  this->getWeaponManager()->setSlotPosition(1, Vector(-2.6, .1, 3.0));
+  this->getWeaponManager()->setSlotCapability(1, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+
+  this->getWeaponManager()->setSlotPosition(2, Vector(-1.5, .5, -.5));
+  this->getWeaponManager()->setSlotDirection(2, Quaternion(-M_PI_4*.5, Vector(1,0,0)));
+
+  this->getWeaponManager()->setSlotPosition(3, Vector(-1.5, .5, .5));
+  this->getWeaponManager()->setSlotDirection(3, Quaternion(M_PI_4*.5, Vector(1,0,0)));
+
+  this->getWeaponManager()->setSlotPosition(4, Vector(-1.5, -.5, .5));
+  this->getWeaponManager()->setSlotDirection(4, Quaternion(-M_PI_4*.5+M_PI, Vector(1,0,0)));
+
+  this->getWeaponManager()->setSlotPosition(5, Vector(-1.5, -.5, -.5));
+  this->getWeaponManager()->setSlotDirection(5, Quaternion(+M_PI_4*.5-M_PI, Vector(1,0,0)));
+//
+   this->getWeaponManager()->setSlotPosition(6, Vector(-1, 0.0, 0));
+   this->getWeaponManager()->setSlotCapability(6, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+   //
+//   this->getWeaponManager()->setSlotPosition(8, Vector(-2.5, -0.3, -2.0));
+//   this->getWeaponManager()->setSlotDirection(8, Quaternion(-M_PI, Vector(1,0,0)));
+//
+//   this->getWeaponManager()->setSlotPosition(9, Vector(-2.5, -0.3, 2.0));
+//   this->getWeaponManager()->setSlotDirection(9, Quaternion(+M_PI, Vector(1,0,0)));:
+
+  this->getWeaponManager()->getFixedTarget()->setParent(this);
+  this->getWeaponManager()->getFixedTarget()->setRelCoor(100000,0,0);
+
+  dynamic_cast<Element2D*>(this->getWeaponManager()->getFixedTarget())->setVisibility( false);
+
+}
+
+/**
+ * loads the Settings of a Helicopter from an XML-element.
+ * @param root the XML-element to load the Spaceship's properties from
+ */
+void Hover::loadParams(const TiXmlElement* root)
+{
+  static_cast<WorldEntity*>(this)->loadParams(root);
+}
+
+
+
+
+void Hover::enter()
+{
+  dynamic_cast<Element2D*>(this->getWeaponManager()->getFixedTarget())->setVisibility( true);
+  this->attachCamera();
+
+
+}
+
+void Hover::leave()
+{
+  dynamic_cast<Element2D*>(this->getWeaponManager()->getFixedTarget())->setVisibility( false);
+  this->detachCamera();
+
+}
+
+
+/**
+ *  effect that occurs after the Helicopter is spawned
+*/
+void Hover::postSpawn ()
+{
+  //setCollision(new CollisionCluster(1.0, Vector(0,0,0)));
+}
+
+/**
+ *  the action occuring if the spaceship left the game
+*/
+void Hover::leftWorld ()
+{}
+
+/**
+ *  this function is called, when two entities collide
+ * @param entity: the world entity with whom it collides
+ *
+ * Implement behaviour like damage application or other miscellaneous collision stuff in this function
+ */
+void Hover::collidesWith(WorldEntity* entity, const Vector& location)
+{
+  if (entity->isA(CL_TURRET_POWER_UP))
+  {
+    this->ADDWEAPON();
+    }
+//  PRINTF(3)("collision %s vs %s @ (%f,%f,%f)\n", this->getClassName(), entity->getClassName(), location.x, location.y, location.z);
+}
+
+
+
+/**
+ *  the function called for each passing timeSnap
+ * @param time The timespan passed since last update
+*/
+void Hover::tick (float time)
+{
+  
+  
+  Quaternion xDir = Quaternion(-M_PI/4*xMouse*mouseSensitivity, Vector(0,1,0));
+  Quaternion yDir = Quaternion(-M_PI/4*yMouse*mouseSensitivity, Vector(0,0,1));
+    
+  if ((this->getAbsDirY()).y < 0.8)
+  {
+     if((this->getAbsDirX()).y > 0)
+     {
+        if(yMouse > 0)  this->shiftDir(xDir*yDir);
+        else this->shiftDir(xDir);
+     }
+     else
+     {
+         if(yMouse < 0) this->shiftDir(xDir*yDir);
+         else this->shiftDir(xDir);
+     }
+  }
+  else this->shiftDir(xDir*yDir);
+  
+  if((this->getAbsDirZ()).y > 0.1) this->shiftDir(Quaternion(0.01,Vector(1,0,0)));
+  else if((this->getAbsDirZ()).y < -0.1) this->shiftDir(Quaternion(-0.01,Vector(1,0,0)));
+
+  
+  // spaceship controlled movement
+  this->calculateVelocity(time);
+
+  Vector move = (velocity)*time;
+
+  // this is the air friction (necessary for a smooth control)
+  if(velocity.len() != 0) velocity -= velocity*0.1;
+
+  //readjust
+ // if (this->getAbsDirZ().y > 0.1) this->shiftDir(Quaternion(time*0.3, Vector(1,0,0)));
+  //else if (this->getAbsDirZ().y < -0.1) this->shiftDir(Quaternion(-time*0.3, Vector(1,0,0)));
+
+  //SDL_WarpMouse(GraphicsEngine::getInstance()->getResolutionX()/2, GraphicsEngine::getInstance()->getResolutionY()/2);
+
+  this->shiftCoor (move);
+  //this->shiftDir(Quaternion(-M_PI/4*tailrotorspeed, Vector(0,1,0)));
+
+  this->getWeaponManager()->tick(time);
+  // weapon system manipulation
+  this->weaponAction();
+}
+
+/**
+ *  calculate the velocity
+ * @param time the timeslice since the last frame
+*/
+void Hover::calculateVelocity (float time)
+{
+  Vector accel(0.0, 0.0, 0.0);
+  float rotValX = 0.0;
+  float rotValZ = 0.0;
+  /* FIXME: calculating the direction and orthDirection every timeSlice is redundant! save it somewhere */
+  /* calculate the direction in which the craft is heading  */
+
+  if( this->bUp )
+   {
+     //this->shiftCoor(this->getAbsDirX());
+     //accel -= this->getAbsDirY();
+     
+     accel += Vector((this->getAbsDirX()).x,0,(this->getAbsDirX()).z);
+     //if((this->getAbsDirX()).y >= -0.1) rotValZ -= time;
+   }
+
+  if( this->bDown )
+   {
+     //this->shiftCoor((this->getAbsDirX())*-1);
+     //accel -= this->getAbsDirY();
+     
+     accel -= Vector((this->getAbsDirX()).x,0,(this->getAbsDirX()).z);
+     //rotValZ += time;
+   }
+
+  if( this->bLeft /* > -this->getRelCoor().z*2*/)
+  {
+    //this->shiftDir(Quaternion(time, Vector(0,1,0)));
+    //accel -= this->getAbsDirY();
+    //velocityDir.normalize();
+    
+    accel -= Vector((this->getAbsDirZ()).x,0,(this->getAbsDirZ()).z);
+    //rotValX -= time;
+  }
+
+  if( this->bRight /* > this->getRelCoor().z*2*/)
+  {
+    //this->shiftDir(Quaternion(-time, Vector(0,1,0)));
+    //accel += this->getAbsDirY();
+    //velocityDir.normalize();
+    
+    accel += Vector((this->getAbsDirZ()).x,0,(this->getAbsDirZ()).z);
+    //rotValX += time;
+  }
+
+  if( this->bRollL /* > -this->getRelCoor().z*2*/)
+  {
+    this->shiftDir(Quaternion(-time, Vector(1,0,0)));
+    //accel -= rightDirection;
+    //velocityDir.normalize();
+    //rot +=Vector(1,0,0);
+    //rotVal -= .4;
+  }
+  if( this->bRollR /* > this->getRelCoor().z*2*/)
+  {
+    this->shiftDir(Quaternion(time, Vector(1,0,0)));
+
+    //accel += rightDirection;
+    //velocityDir.normalize();
+    //rot += Vector(1,0,0);
+    //rotVal += .4;
+  }
+  if (this->bAscend )
+  {
+    //this->shiftDir(Quaternion(time, Vector(0,0,1)));
+
+    accel += this->getAbsDirY();
+    //rotorspeed += 0.05;
+    //if (rotorspeed >= 2) rotorspeed = 2;
+    //velocityDir.normalize();
+    //rot += Vector(0,0,1);
+    //rotVal += .4;
+  }
+  else
+  {
+    //if(rotorspeed >= 1.05) rotorspeed -= 0.05;
+  }
+
+  if (this->bDescend )
+  {
+    //this->shiftDir(Quaternion(-time, Vector(0,0,1)));
+
+    accel -= this->getAbsDirY();
+    //rotorspeed -= 0.05;
+    //if (rotorspeed <= 0) rotorspeed = 0;
+    //velocityDir.normalize();
+    //rot += Vector(0,0,1);
+    //rotVal -= .4;
+  }
+  else
+  {
+    //if(rotorspeed <= 0.05) rotorspeed += 0.05;
+  }
+
+  velocity += accel*4;
+  //if((this->getAbsDirX()).y <= 0.3 && (this->getAbsDirX()).y >= -0.3) this->shiftDir(Quaternion(rotValZ, Vector(0,0,1)));
+  //if((this->getAbsDirZ()).y <= 0.3 && (this->getAbsDirZ()).y >= -0.3) this->shiftDir(Quaternion(rotValX, Vector(1,0,0)));
+}
+
+
+void Hover::draw() const
+{
+  WorldEntity::draw();
+
+  this->getWeaponManager()->draw();
+}
+
+
+/**
+ * weapon manipulation by the player
+*/
+void Hover::weaponAction()
+{
+  if( this->bFire)
+    {
+      this->getWeaponManager()->fire();
+    }
+}
+
+/**
+ * @todo switch statement ??
+ */
+void Hover::process(const Event &event)
+{
+
+
+  if( event.type == KeyMapper::PEV_LEFT)
+      this->bLeft = event.bPressed;
+  else if( event.type == KeyMapper::PEV_RIGHT)
+      this->bRight = event.bPressed;
+  else if( event.type == KeyMapper::PEV_FIRE1)
+      this->bFire = event.bPressed;
+  else if( event.type == KeyMapper::PEV_NEXT_WEAPON && event.bPressed)
+    this->getWeaponManager()->nextWeaponConfig();//if( !event.bPressed) this->bWeaponChange = !this->bWeaponChange;
+  else if ( event.type == KeyMapper::PEV_PREVIOUS_WEAPON && event.bPressed)
+    this->getWeaponManager()->previousWeaponConfig();
+  else if( event.type == SDLK_e)
+    this->bAscend = event.bPressed; //this->shiftCoor(0,.1,0);
+  else if( event.type == SDLK_c)
+    this->bDescend = event.bPressed; //this->shiftCoor(0,-.1,0);
+  else if( event.type == KeyMapper::PEV_UP)
+    this->bUp = event.bPressed; //this->shiftCoor(0,.1,0);
+  else if( event.type == KeyMapper::PEV_DOWN)
+    this->bDown = event.bPressed; //this->shiftCoor(0,-.1,0);
+  else if( event.type == EV_MOUSE_MOTION)
+  {
+    this->xMouse = event.xRel*mouseSensitivity;
+    this->yMouse = event.yRel*mouseSensitivity;
+  }
+}
+
+#include "weapons/aiming_turret.h"
+// FIXME THIS MIGHT BE CONSIDERED EITHER A FEATURE, OR A BUG
+void Hover::ADDWEAPON()
+{
+  Weapon* turret = NULL;
+
+  if ((float)rand()/RAND_MAX < .1)
+  {
+    //if (this->getWeaponManager()->hasFreeSlot(2, WTYPE_TURRET))
+    {
+      turret = new Turret();
+      this->addWeapon(turret, 2);
+      this->getWeaponManager()->changeWeaponConfig(2);
+    }
+  }
+  else
+  {
+    //if (this->getWeaponManager()->hasFreeSlot(3))
+    {
+      turret = new AimingTurret();
+      this->addWeapon(turret, 3);
+
+      this->getWeaponManager()->changeWeaponConfig(3);
+    }
+  }
+
+  if(turret != NULL)
+  {
+    turret->setName("Turret");
+    turret->setStateDuration(WS_SHOOTING, (float)rand()/RAND_MAX*.5+.1);
+  }
+}
Index: /branches/network/src/world_entities/space_ships/hover.h
===================================================================
--- /branches/network/src/world_entities/space_ships/hover.h	(revision 6693)
+++ /branches/network/src/world_entities/space_ships/hover.h	(revision 6693)
@@ -0,0 +1,70 @@
+
+/*!
+ * @file helicopter.h
+ * Implements the Control of a Hover
+ */
+
+#ifndef _HOVER_H
+#define _HOVER_H
+
+#include "playable.h"
+
+
+class Hover : public Playable
+{
+
+  public:
+
+    Hover();
+    Hover(const char* fileName);
+    Hover(const TiXmlElement* root);
+    virtual ~Hover();
+
+    void init();
+    void loadParams(const TiXmlElement* root);
+
+    virtual void enter();
+    virtual void leave();
+
+    virtual void postSpawn();
+    virtual void leftWorld();
+
+    virtual void collidesWith(WorldEntity* entity, const Vector& location);
+    virtual void tick(float time);
+    virtual void draw() const;
+
+    virtual void process(const Event &event);
+
+
+
+  private:
+    void calculateVelocity(float time);
+    void weaponAction();
+
+    // !! temporary !!
+    void ADDWEAPON();
+
+    bool                  bUp;                //!< up button pressed.
+    bool                  bDown;              //!< down button pressed.
+    bool                  bLeft;              //!< left button pressed.
+    bool                  bRight;             //!< right button pressed.
+    bool                  bAscend;            //!< ascend button pressed.
+    bool                  bDescend;           //!< descend button presses.
+    bool                  bFire;              //!< fire button pressed.
+    bool                  bRollL;             //!< rolling button pressed (left)
+    bool                  bRollR;             //!< rolling button pressed (right)
+
+    float                 xMouse;             //!< mouse moved in x-Direction
+    float                 yMouse;             //!< mouse moved in y-Direction
+    float                 mouseSensitivity;   //!< the mouse sensitivity
+
+    Vector                velocity;           //!< the velocity of the player.
+    Vector                velocityDir;        //!< the direction of the velocity of the spaceship
+    float                 travelSpeed;        //!< the current speed of the player (to make soft movement)
+    float                 acceleration;       //!< the acceleration of the player.
+    
+    float                 airViscosity;
+
+};
+
+#endif /* _HOVER_H */
Index: /branches/network/src/world_entities/space_ships/space_ship.cc
===================================================================
--- /branches/network/src/world_entities/space_ships/space_ship.cc	(revision 6692)
+++ /branches/network/src/world_entities/space_ships/space_ship.cc	(revision 6693)
@@ -128,6 +128,4 @@
   this->addWeapon(cannon, 0, 6);
 
-  //this->addWeapon(turret, 3, 0);
-
   this->getWeaponManager()->changeWeaponConfig(1);
 
@@ -137,14 +135,20 @@
   bFire = false;
   xMouse = yMouse = 0;
+  yInvert = 1;
   mouseSensitivity = 0.001;
-  airViscosity = 1.0;
-  cycle = 0.0;
+  airViscosity = 0.05;
+  controlVelocityX = 25;
+  controlVelocityY = 150;
+  shipInertia = 0.5		;
+//  cycle = 0.0;
 
   this->setMaxEnergy(100);
   this->setEnergy(80);
 
-  travelSpeed = 15.0;
-  this->velocity = Vector(0.0,0.0,0.0);
+  travelSpeed = 40.0;
+  acceleration = 3;
+  this->velocity = this->getAbsDirX()*travelSpeed;
   this->mouseDir = this->getAbsDir();
+  this->pitchDir = this->getAbsDir();
 
 //   GLGuiButton* button = new GLGuiPushButton();
@@ -160,15 +164,15 @@
 
   //add events to the eventlist
-  registerEvent(SDLK_w);
-  registerEvent(SDLK_s);
-  registerEvent(SDLK_a);
-  registerEvent(SDLK_d);
-  registerEvent(SDLK_q);
-  registerEvent(SDLK_e);
+  registerEvent(KeyMapper::PEV_UP);
+  registerEvent(KeyMapper::PEV_DOWN);
+  registerEvent(KeyMapper::PEV_LEFT);
+  registerEvent(KeyMapper::PEV_RIGHT);
+  //registerEvent(SDLK_q);
+  //registerEvent(SDLK_e);
   registerEvent(KeyMapper::PEV_FIRE1);
   registerEvent(KeyMapper::PEV_NEXT_WEAPON);
   registerEvent(KeyMapper::PEV_PREVIOUS_WEAPON);
-  registerEvent(SDLK_PAGEUP);
-  registerEvent(SDLK_PAGEDOWN);
+  //registerEvent(SDLK_PAGEUP);
+  //registerEvent(SDLK_PAGEDOWN);
   registerEvent(EV_MOUSE_MOTION);
 
@@ -285,4 +289,18 @@
   this->weaponAction();
 
+  if( xMouse != 0 || yMouse != 0)
+   {
+    if (xMouse > controlVelocityX) xMouse = controlVelocityX;
+    else if (xMouse < -controlVelocityX) xMouse = -controlVelocityX;
+    if (yMouse > controlVelocityY) yMouse = controlVelocityY;
+    else if (yMouse < -controlVelocityY) yMouse = -controlVelocityY;
+
+    pitchDir = (Quaternion(xMouse*mouseSensitivity*0.5, Vector(1,0,0)));
+
+    mouseDir *= (Quaternion(-M_PI/4*xMouse*mouseSensitivity, Vector(0,1,0))*Quaternion(-M_PI/4*yMouse*mouseSensitivity*yInvert, Vector(0,0,1))*pitchDir);
+    xMouse = yMouse = 0;
+   }
+
+
 //   if( this != State::getPlayer()->getControllable())
 //     return;
@@ -291,5 +309,5 @@
   this->calculateVelocity(time);
 
-  Vector move = (velocity)*time;
+  Vector move = velocity*time;
 
   //orient the velocity in the direction of the spaceship.
@@ -299,5 +317,5 @@
 
   //orient the spaceship in direction of the mouse
-   rotQuat = Quaternion::quatSlerp( this->getAbsDir(), mouseDir, fabsf(time)*3.0);
+   rotQuat = Quaternion::quatSlerp( this->getAbsDir(), mouseDir, fabsf(time)*shipInertia);
    if (this->getAbsDir().distance(rotQuat) > 0.00000000000001)
     this->setAbsDir( rotQuat);
@@ -305,5 +323,10 @@
 
   // this is the air friction (necessary for a smooth control)
-  if(velocity.len() != 0) velocity -= velocity*0.01;
+  if(travelSpeed >= 120) velocity -= velocity.getNormalized()*travelSpeed*travelSpeed*0.0001;
+  else if (travelSpeed <= 80) velocity -= velocity.getNormalized()*travelSpeed*0.001;
+
+  //other physics (gravity)
+  //if(travelSpeed < 120)
+  //move += Vector(0,-1,0)*60*time + Vector(0,1,0)*travelSpeed/2*time;
 
   //hoover effect
@@ -312,11 +335,4 @@
 
   //readjust
-
-  /*
-    In the game "Yager" the spaceship gets readjusted when the player moves the mouse.
-    I (bknecht) go and check it out how they do it, we could probably use this also in Orxonox.
-  */
-  //if (xMouse != 0 && yMouse != 0)
-
   //if (this->getAbsDirZ().y > 0.1) this->shiftDir(Quaternion(time*0.3, Vector(1,0,0)));
   //else if (this->getAbsDirZ().y < -0.1) this->shiftDir(Quaternion(-time*0.3, Vector(1,0,0)));
@@ -324,5 +340,5 @@
   //SDL_WarpMouse(GraphicsEngine::getInstance()->getResolutionX()/2, GraphicsEngine::getInstance()->getResolutionY()/2);
 
-  this->shiftCoor (move);
+  this->shiftCoor(move);
 
 
@@ -343,15 +359,12 @@
   /* calculate the direction in which the craft is heading  */
 
-  Plane plane(Vector(0,1,0), Vector(0,0,0));
+  //Plane plane(Vector(0,1,0), Vector(0,0,0));
 
   if( this->bUp )
    {
      //this->shiftCoor(this->getAbsDirX());
-      accel += (this->getAbsDirX())*2;
-
-      /* Heli-Steuerung
-         accel += (this->getAbsDirX()*2;
-         if(
-      */
+      //accel += (this->getAbsDirX())*2;
+      accel += (this->getAbsDirX())*acceleration;
+
    }
 
@@ -359,5 +372,6 @@
    {
      //this->shiftCoor((this->getAbsDirX())*-1);
-     accel -= (this->getAbsDirX())*2;
+     //accel -= (this->getAbsDirX())*2;
+     accel -= (this->getAbsDirX())*0.5*acceleration;
    }
 
@@ -383,5 +397,5 @@
   if( this->bRollL /* > -this->getRelCoor().z*2*/)
   {
-    mouseDir *= Quaternion(-time, Vector(1,0,0));
+    mouseDir *= Quaternion(-time*2, Vector(1,0,0));
 //    accel -= rightDirection;
     //velocityDir.normalize();
@@ -391,5 +405,5 @@
   if( this->bRollR /* > this->getRelCoor().z*2*/)
   {
-    mouseDir *= Quaternion(time, Vector(1,0,0));
+    mouseDir *= Quaternion(time*2, Vector(1,0,0));
 
     //    accel += rightDirection;
@@ -438,9 +452,7 @@
 void SpaceShip::process(const Event &event)
 {
-
-
-  if( event.type == SDLK_a)
+  if( event.type == KeyMapper::PEV_LEFT)
       this->bRollL = event.bPressed;
-  else if( event.type == SDLK_d)
+  else if( event.type == KeyMapper::PEV_RIGHT)
       this->bRollR = event.bPressed;
   else if( event.type == KeyMapper::PEV_FIRE1)
@@ -452,15 +464,12 @@
   else if ( event.type == KeyMapper::PEV_PREVIOUS_WEAPON && event.bPressed)
     this->previousWeaponConfig();
-  else if( event.type == SDLK_w)
+  else if( event.type == KeyMapper::PEV_UP)
     this->bUp = event.bPressed; //this->shiftCoor(0,.1,0);
-  else if( event.type == SDLK_s)
+  else if( event.type == KeyMapper::PEV_DOWN)
     this->bDown = event.bPressed; //this->shiftCoor(0,-.1,0);
   else if( event.type == EV_MOUSE_MOTION)
   {
-    this->xMouse = event.xRel;
-    this->yMouse = event.yRel;
-    mouseDir *= (Quaternion(-M_PI/4*xMouse*mouseSensitivity, Vector(0,1,0))*Quaternion(-M_PI/4*yMouse*mouseSensitivity, Vector(0,0,1)));
-   // if( xMouse*xMouse + yMouse*yMouse < 0.9)
-     //this->setAbsDir(mouseDir);
+    this->xMouse += event.xRel;
+    this->yMouse += event.yRel;
   }
 }
Index: /branches/network/src/world_entities/space_ships/space_ship.h
===================================================================
--- /branches/network/src/world_entities/space_ships/space_ship.h	(revision 6692)
+++ /branches/network/src/world_entities/space_ships/space_ship.h	(revision 6693)
@@ -65,9 +65,14 @@
     float                 yMouse;             //!< mouse moved in y-Direction
     float                 mouseSensitivity;   //!< the mouse sensitivity
-    float                 cycle;              //!< hovercycle
+    int                   yInvert;
+    int                   controlVelocityX;
+    int                   controlVelocityY;
+//    float                 cycle;              //!< hovercycle
 
     Vector                velocity;           //!< the velocity of the player.
     Quaternion            mouseDir;           //!< the direction where the player wants to fly
+    float                 shipInertia;        //!< the inertia of the ship(how fast the ship reacts to a mouse input)
     Quaternion            rotQuat;
+    Quaternion            pitchDir;
     float                 travelSpeed;        //!< the current speed of the player (to make soft movement)
     float                 acceleration;       //!< the acceleration of the player.
Index: /branches/network/src/world_entities/weapons/aim.cc
===================================================================
--- /branches/network/src/world_entities/weapons/aim.cc	(revision 6692)
+++ /branches/network/src/world_entities/weapons/aim.cc	(revision 6693)
@@ -73,4 +73,6 @@
   this->source = NULL;
 
+  this->range = 0;
+  this->angle = 0;
   this->anim = new tAnimation<Aim>(this, &Aim::setSize);
   this->anim->setInfinity(ANIM_INF_CONSTANT);
@@ -101,13 +103,19 @@
 }
 
-void Aim::searchTarget(float range)
+void Aim::searchTarget()
 {
   std::list<WorldEntity*>::iterator entity;
-
+  Vector diffVec(0.0, 0.0, 0.0);
+  diffVec = ( this->getAbsCoor() - this->source->getAbsCoor() );
+
+//only look for target if the aim hasn`t locked a target yet or if the actual target is out of range
+  if( this == PNode::getNullParent() || diffVec.len() > range  || ( acos( (this->source->getAbsDirX()).dot(diffVec)/(diffVec.len() * (this->source->getAbsDirX()).len() ) ) > angle))
   for (entity = State::getObjectManager()->getObjectList(OM_GROUP_00).begin();
        entity != State::getObjectManager()->getObjectList(OM_GROUP_00).end();
        entity ++)
   {
-    if (this->source->getAbsCoor().x < (*entity)->getAbsCoor().x && (this->source->getAbsCoor() - (*entity)->getAbsCoor()).len() < range)
+    diffVec = ( (*entity)->getAbsCoor() - this->source->getAbsCoor() );
+
+    if ( diffVec.len() < range  &&  acos( (this->source->getAbsDirX()).dot(diffVec)/(diffVec.len() * (this->source->getAbsDirX()).len() ) ) < angle)
     {
       if (this->getParent() != (*entity))
@@ -119,6 +127,7 @@
     }
   }
-}
-
+//if no target found:
+  this->setParent(PNode::getNullParent());
+}
 
 
@@ -155,6 +164,6 @@
 
 
-  if (this->source->getAbsCoor().x > this->getAbsCoor().x )
-    this->searchTarget(1000);
+//  if (this->source->getAbsCoor().x > this->getAbsCoor().x )
+     this->searchTarget();
 //   float z = 0.0f;
 //   glReadPixels ((int)this->getAbsCoor2D().x,
Index: /branches/network/src/world_entities/weapons/aim.h
===================================================================
--- /branches/network/src/world_entities/weapons/aim.h	(revision 6692)
+++ /branches/network/src/world_entities/weapons/aim.h	(revision 6693)
@@ -38,5 +38,8 @@
   inline PNode* getTarget(PNode* target) { return this->getParent(); };
 
-  void searchTarget(float range);
+  void searchTarget();
+
+  void setRange(float range){this->range = range;};
+  void setAngle(float angle){this->angle = angle;};
 
   void setSize(float size);
@@ -53,4 +56,7 @@
    tAnimation<Aim>* anim;
 
+   float            range;                //!<
+   float            angle;                //!<
+
    PNode*           source;               //!< Where this Shot has come from.
 
Index: /branches/network/src/world_entities/weapons/aiming_turret.cc
===================================================================
--- /branches/network/src/world_entities/weapons/aiming_turret.cc	(revision 6692)
+++ /branches/network/src/world_entities/weapons/aiming_turret.cc	(revision 6693)
@@ -86,5 +86,5 @@
   this->setStateDuration(WS_DEACTIVATING, .4);
 
-  this->setMaximumEnergy(10000, 50);
+  this->setEnergyMax(10000);
   this->increaseEnergy(100000);
 
@@ -98,4 +98,6 @@
   this->target = new Aim(this);
   this->target->setVisibility(false);
+  this->target->setRange(100);
+  this->target->setAngle(M_PI);
 }
 
@@ -146,5 +148,5 @@
   pj->setAbsDir(this->getAbsDir());
   pj->activate();
-  this->target->searchTarget(100);
+  this->target->searchTarget();
 }
 
Index: /branches/network/src/world_entities/weapons/ammo_container.cc
===================================================================
--- /branches/network/src/world_entities/weapons/ammo_container.cc	(revision 6693)
+++ /branches/network/src/world_entities/weapons/ammo_container.cc	(revision 6693)
@@ -0,0 +1,93 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer: ...
+*/
+
+//#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_
+
+#include "ammo_container.h"
+
+#include "weapon.h"
+
+#include <assert.h>
+
+using namespace std;
+
+/**
+ * standard constructor
+ * @todo this constructor is not jet implemented - do it
+*/
+AmmoContainer::AmmoContainer (ClassID projectileType, float maxEnergy)
+{
+   this->setClassID(CL_AMMO_CONTAINER, "AmmoContainer");
+
+   this->energy = 0.0;
+   this->maxEnergy = maxEnergy;
+}
+
+
+/**
+ * standard deconstructor
+*/
+AmmoContainer::~AmmoContainer ()
+{
+  // delete what has to be deleted here
+}
+
+
+
+float AmmoContainer::increaseEnergy(float energy)
+{
+  this->energy += energy;
+
+  if (unlikely(this->energy > this->maxEnergy))
+  {
+    float retEnergy = this->energy - this->maxEnergy;
+    this->energy = this->maxEnergy;
+    return retEnergy;
+  }
+  else
+    return 0.0f;
+}
+
+
+float AmmoContainer::decreaseEnergy(float energy)
+{
+  this->energy -= energy;
+
+  if (unlikely(this->energy < 0))
+  {
+    float retEnergy = 0 - this->energy;
+    this->energy = 0;
+    return retEnergy;
+  }
+  else
+    return 0.0f;
+}
+
+bool AmmoContainer::weaponValid(const Weapon* weapon)
+{
+  return (weapon->isA(this->projectileType));
+}
+
+
+void AmmoContainer::fillWeapon(Weapon* weapon)
+{
+  assert (weapon != NULL);
+  assert (this->weaponValid(weapon));
+
+  float fillEnergy = weapon->getEnergyMax();
+
+  float restEnergy = weapon->increaseEnergy(fillEnergy);
+  this->decreaseEnergy(fillEnergy - restEnergy);
+}
Index: /branches/network/src/world_entities/weapons/ammo_container.h
===================================================================
--- /branches/network/src/world_entities/weapons/ammo_container.h	(revision 6693)
+++ /branches/network/src/world_entities/weapons/ammo_container.h	(revision 6693)
@@ -0,0 +1,46 @@
+/*!
+ * @file proto_class.h
+ * @brief Definition of ...
+*/
+
+#ifndef _AMMO_CONTAINER_H
+#define _AMMO_CONTAINER_H
+
+#include "base_object.h"
+
+
+// FORWARD DECLARATION
+class Weapon;
+
+#define DEFAULT_MAX_ENERGY 100
+
+//! A class for Storing energy of Projectiles.
+class AmmoContainer : public BaseObject {
+
+ public:
+  AmmoContainer(ClassID projectileType, float maxEnergy = DEFAULT_MAX_ENERGY);
+  virtual ~AmmoContainer();
+
+  bool operator=(ClassID projectileType) const { return (this->projectileType == projectileType); };
+  ClassID getProjectileType() const { return this->projectileType; };
+
+  float increaseEnergy(float energy);
+  float decreaseEnergy(float energy);
+
+  float getStoredEnergy() const { return this->energy; };
+  float getMaxEnergy() const { return this->maxEnergy; };
+
+  void increaseMaxEnergy(float increase);
+
+  bool weaponValid(const Weapon* weapon);
+  void fillWeapon(Weapon* weapon);
+
+
+ private:
+   float  energy;
+   float  maxEnergy;
+
+   ClassID projectileType;
+};
+
+#endif /* _AMMO_CONTAINER_H */
Index: /branches/network/src/world_entities/weapons/cannon.cc
===================================================================
--- /branches/network/src/world_entities/weapons/cannon.cc	(revision 6692)
+++ /branches/network/src/world_entities/weapons/cannon.cc	(revision 6693)
@@ -81,5 +81,5 @@
   this->setStateDuration(WS_DEACTIVATING, .4);
 
-  this->setMaximumEnergy(100, 20);
+  this->setEnergyMax(100);
   this->increaseEnergy(100);
   //this->minCharge = 2;
